%%%  Department of Information Systems and Computer Science
%%%  National University of Singapore
%%%  3101 Project: Flexible Timetabling
%%%  Students: Lee Mei Tien, Leo Hui Ting, Tay Choon Yee
%%%  Supervisor: A/P Joxan Jaffar
%%%  Submission Date: 6 October

%%%  File: controller.oz
%%%  Description: ...

   InfoText = 'Department of Information Systems and Computer Science
National University of Singapore
3101 Project: Flexible Timetabling
Students: Lee Mei Tien, Leo Hui Ting, Tay Choon Yee
Supervisor: A/P Joxan Jaffar
Submission Date: 6 October'

  proc {Controller}
      TopWindow = {New Tk.toplevel tkInit(title:'Department Tutorial Time Tabling')}

      Menu = {New Tk.frame
	      tkInit(parent:TopWindow borderwidth:2)}
      

      fun {MakeMenu Text Ms}
	 Menus = {Map Ms fun{$ M}
			    case M of sep then separator
			    else 
			       command(label: M.1
				       action: proc{$}
						  case M of _#A then {A}
						  [] _#Object#Meth
						  then
						     {Object Meth}
						  [] _#Proc#Arg1#Arg2
						  then
						     {Proc Arg1 Arg2}
						  end
					       end)
			    end
			 end}
      in
	 menubutton(text:   Text
		    menu:   Menus)
      end

      proc {Exit}
	 {TopWindow tkClose}
      end

      MFile  = {MakeMenu 'File'
		['  Load Problem '#DoFileOp#readProblem#read
		 '  Edit Problem '#DoFileOp#edit#read
		 sep
		 '  Load Solution '#DoFileOp#readSol#read
		 '  Save Solution '#DoFileOp#save#written
		 sep
		 '  Exit '#Exit]}
      MCompute = {MakeMenu 'Compute'
		  [
		    '  Next Solution '#TimeTable#next
		    '  Best Solution '#TimeTable#optimizeProblem
		    sep
		    '  Interrupt Search '#TimeTable#anyTime
		    sep
		    '  Explore Searchtree '#TimeTable#explore]}
      MOutput = {MakeMenu 'Output'
		 ['  Display Graphical '#TimeTable#graphic
		  '  Display Browsing '#TimeTable#browse
		  '  Display Textual '#TimeTable#text
		  sep
		  '  Print Graphical '#TimeTable#grab
		  '  Print Textual  '#TimeTable#print]}

      MDesk  = {MakeMenu 'Help' ['About'#About]}

      Menus   = {TkTools.menubar Menu Menu
		 [MFile MCompute MOutput MDesk]
		 nil }
      
      proc {DoFileOp MessageName Flag}
	 DemoPath = HomePath # '/department2/'
	 FSel = {Tk.return tk_getOpenFile(filetypes:  q(q('Data files' q('.ozt'))
							q('All Files'        '*'))
					  initialdir: DemoPath)}
      in
	 case FSel of nil then skip
	 else
	    {ControllerLabel tk(configure text:'File '#Flag)}     
	    {TimeTable MessageName(FSel)}
	 end
      end

      proc {DoFileOpAlone MessageName Flag}
	 {ControllerLabel tk(configure text:'File '#Flag)}     
	 {TimeTable MessageName(HomePath # '/department/' # 'DataOut2.ozt')}
      end
      
      % -------------------------------------------------
      
      proc {About}
         AboutWindow = {New Tk.toplevel tkInit(parent:TopWindow)}
         OK = {New Tk.button
	       tkInit(parent:AboutWindow text:'OK' relief:raised
		      borderwidth:2
		      action: AboutWindow # tkClose)}
         Message = {New Tk.message
		    tkInit(parent:AboutWindow
			   width: 500
			   text: InfoText)}
      in
         {Tk.batch [wm(title AboutWindow "What is it?")
		    wm(iconname AboutWindow "About")
		    pack(Message side:top)
		    pack(OK side:bottom fill:x)]}
      end

      % -------------------------------------------------


      proc {Compute Message Display}
	 {ControllerLabel tk(configure text:"Computing...")}
	 {TimeTable Message} 
	 thread
	    {Wait {TimeTable get($)}}
	    {ControllerLabel tk(configure text:"done")}
	    {TimeTable Display}
	 end
      end
      
      % -------------------------------------------------

      TitleCanvas = {New Tk.canvas tkInit(parent:TopWindow
					  height:130 width:620)}


      ControllerLabel = {New Tk.label tkInit(parent:Menu text:'' )}
      
   in
      {TimeTable setControllerLabel(ControllerLabel)}
      {TimeTable setTopWindow(TopWindow)}
      
      {Tk.send pack(Menus side:left)}
      {Tk.send pack(ControllerLabel side:right)}

      {Tk.send pack(Menu side:top fill:x)}

      {TitleCanvas tk(crea bitmap 0 0 bitmap: "@" #
		      {System.get home} #
		      '/demo/bitmaps/college/' #
		      "title.xbm"
		      anchor:nw)}
      {TitleCanvas tk(crea text 240 40
		      text:"Time Table" anchor:nw
		      font:'-adobe-helvetica-bold-o-*-*-18-*')}
      {TitleCanvas tk(crea text 240 65
		      text:"Manager" anchor:nw
		      font:'-adobe-helvetica-bold-o-*-*-18-*')}

      {Tk.send pack(TitleCanvas side:top)}

   end


