%% declare V1 and V2
declare X
[V1 V2]=X

%% display the values
{Browse X}

%% V1 and V2 are 0/1 variables
X:::0#1

%% NOT V1 \/ V2
{FD.disj {FD.nega V1} V2 1}

%% V1 \/ NOT V2
{FD.disj V1 {FD.nega V2} 1}

%% V1 \/ V2
{FD.disj V1 V2 1}

V1 = 0


%% encapsulate SAT
%% in a procedure

declare
proc {SAT X}
   [V1 V2]=X
in
   X:::0#1
   {FD.disj {FD.nega V1} V2 1}
   {FD.disj V1 {FD.nega V2} 1}
   {FD.disj V1 V2 1}
end

declare MyX
{Browse MyX}
{SAT MyX}

MyX.1 = 0

declare MyY
{Browse MyY}
{SAT MyY}

MyY.1 = 1


%% encapsulate SAT
%% in space

declare
S={Space.new SAT}

{Browse {Space.ask S}}

{Browse {Space.peek S}}

{Space.inject S
 proc {$ X} X.1 =: 0 end}

{Browse {Space.ask S}}


%% make a clone as
%% backup copy

declare
S={Space.new SAT}

declare
C={Space.clone S}

{Space.inject S
 proc {$ X} X.1 =: 0 end}

{Browse {Space.ask S}}

{Space.inject C
 proc {$ X} X.1 =: 1 end}

{Browse {Space.ask C}}

{Browse {Space.peek C}}


%% choice points

declare
proc {SAT X}
   [V1 V2]=X
in
   X:::0#1
   {FD.disj {FD.nega V1} V2 1}
   {FD.disj V1 {FD.nega V2} 1}
   {FD.disj V1 V2 1}
   
   choice V1 = 0 [] V1 = 1 end
   
end

declare
S={Space.new SAT}

{Browse {Space.ask S}}

declare
C={Space.clone S}

{Space.commit S 1}

{Browse {Space.ask S}}

{Space.commit C 2}

{Browse {Space.ask C}}

{Browse {Space.peek C}}

\insert showmoney

declare
proc {MONEY Root}
   sol(s:S e:E n:N d:D m:M o:O r:R y:Y)=Root
in
   Root ::: 0#9
   {FD.distinct Root}
   S \=: 0 
   M \=: 0
   1000*S + 100*E + 10*N + D
   +            1000*M + 100*O + 10*R + E
   =: 10000*M + 1000*O + 100*N + 10*E + Y
end

declare
S={Space.new MONEY}

{Browse {Space.ask S}}

{ShowMoney {Space.peek S}}


%% enumerate values of E
%% in choice points

declare
proc {MONEY Root}
   sol(s:S e:E n:N d:D m:M o:O r:R y:Y)=Root
in
   Root ::: 0#9
   {FD.distinct Root}
   S \=: 0 
   M \=: 0
                1000*S + 100*E + 10*N + D
   +            1000*M + 100*O + 10*R + E
   =: 10000*M + 1000*O + 100*N + 10*E + Y
   
   choice
      Root.e =: 4
   []
      Root.e \=: 4
      choice
	 Root.e =: 5
      []
	 Root.e \=: 5
	 choice
	    Root.e =: 6
	 []
	    Root.e \=: 6
	 end
      end
   end
end

declare
S={Space.new MONEY}

{Browse {Space.ask S}}

declare
C1={Space.clone S}

{Space.commit S 1}

{Browse {Space.ask S}}

{Space.commit C1 2}

declare
C2={Space.clone C1}

{Space.commit C1 1}

{Browse {Space.ask C1}}

{ShowMoney {Space.peek C1}}


%% Depth First Search

declare
fun {DFS S}
   case {Space.ask S}
   of succeeded then S
   [] failed then false
   [] alternatives(2) then
      C={Space.clone S}
   in
      {Space.commit S 1}
      case {DFS S}
      of false then {Space.commit C 2} {DFS C}
      elseof SolS then SolS
      end
   end
end

{ShowMoney
 {Space.peek {DFS {Space.new MONEY}}}}


%% Depth First Engine

declare
fun {DFE Script}
   {Space.peek {DFS {Space.new Script}}}
end

{ShowMoney {DFE MONEY}}


%% Graphical Engine

{ExploreOne MONEY}

{Explorer
 add(information
     proc {$ N R} {ShowMoney R} end)}


%% Distributors generate choice points

declare
proc {MONEY Root}
   sol(s:S e:E n:N d:D m:M o:O r:R y:Y)=Root
in
   Root ::: 0#9
   {FD.distinct Root}
   S \=: 0 
   M \=: 0
                1000*S + 100*E + 10*N + D
   +            1000*M + 100*O + 10*R + E
   =: 10000*M + 1000*O + 100*N + 10*E + Y
   
   %% choice points
   {FD.distribute naive [D E M N O R S Y]}
   
end

{ExploreOne MONEY}


declare
proc {MONEY Root}
   sol(s:S e:E n:N d:D m:M o:O r:R y:Y)=Root
in
   Root ::: 0#9
   {FD.distinct Root}
   S \=: 0 
   M \=: 0
                1000*S + 100*E + 10*N + D
   +            1000*M + 100*O + 10*R + E
   =: 10000*M + 1000*O + 100*N + 10*E + Y
   
   %% variable selection: smallest dom
   %% value selection: largest
   {FD.distribute
    generic(order:size value:max)
    [D E M N O R S Y]}
end

{ExploreOne MONEY}


%% MOST MONEY

declare
proc {MostMoney Root}
   S E N D M O T Y
in
   Root = sol(s:S e:E n:N d:D m:M o:O t:T y:Y)
   Root ::: 0#9
   {FD.distinct Root}
   S \=: 0 
   M \=: 0
   1000*S + 100*E + 10*N + D
   +            1000*M + 100*O + 10*S + T
   =: 10000*M + 1000*O + 100*N + 10*E + Y
   {FD.distribute
    generic(order:size value:max)
    [D E M N O S T Y]}
end

{Explorer
 add(information
     proc {$ N R} {ShowMostMoney R} end)}

{Explorer script(MostMoney)}

declare
proc {Ordering O N}
   O.m*10000 + O.o*1000 + O.n*100 + O.e*10 + O.y
   <:
   N.m*10000 + N.o*1000 + N.n*100 + N.e*10 + N.y
end

{Explorer script(MostMoney Ordering)}
